/*------------------------------------*\
    #OBJECTS.FORM
\*------------------------------------*/
/**
 * Form object.
 */
@import '../1-utils/utils.loader';
@import '../0-settings/settings.objects';

// The form
.#{$inuit-namespace}form,
%#{$inuit-namespace}form {
    margin-top: 0;

    .has-error .error-hint {
        @include form-error-message;
        font-size: .9rem;
        margin: 0 0 10px;
        padding: 10px;
    }

    .error-hint {
        display: none;
    }
}
// defaults for own forms
.c-form {

    display: block;
    background: $drk-color-light-blue;
    margin: 0;
    padding: 15px;

    @media #{$medium-up} {
        padding: 25px
    }

    @media #{$large-up} {
        padding: 25px;
    }

}

.#{$inuit-namespace}form__headline,
%#{$inuit-namespace}form__headline {
    margin-top: 0;
}

// A form section, typically a fieldset element
.#{$inuit-namespace}form__section,
%#{$inuit-namespace}form__section {
    border: 0;
    margin-left: 0;
    margin-right: 0;
    padding: drk-quarter($drk-base-unit) 0;
    padding-bottom: 0;

    + .#{$inuit-namespace}form__section,
    + %#{$inuit-namespace}form__section {
        border: 0;
        margin-top: drk-halve($drk-base-unit);
    }
}

.#{$inuit-namespace}form__section-headline,
%#{$inuit-namespace}form__section-headline {
    margin-top: 0;
}

// A row in a form that contains label and form field
.#{$inuit-namespace}form__item,
%#{$inuit-namespace}form__item {
    margin-bottom: $drk-base-unit-small / 1.15;
    padding: 0;
    width: 98%;

    position: relative;

    @media #{$medium-up}{
        padding: 0 drk-quarter($drk-base-unit) 0 0;

        &.is-last-in-row {
            padding-right: 0;
        }
    }
}

.#{$inuit-namespace}form__item-toggle,
%#{$inuit-namespace}form__item-toggle {
    display: none;

    &.is-active {
        display: block;
    }
}

.#{$inuit-namespace}form__item-headline,
%#{$inuit-namespace}form__item-headline {
    @media #{$small-only} {
        font-size: 1rem;
    }

    @media #{$medium-up} {
        margin: 0 0 1em;
    }
}

.#{$inuit-namespace}form__item-group,
%#{$inuit-namespace}form__item-group {
    @include grid-row;
}

.#{$inuit-namespace}form__label,
%#{$inuit-namespace}form__label {
    background: transparent;
    border-bottom: 1px solid transparent;
    cursor: text;
    display: block;
    font-size: 100%;
    height: 2.25rem;
    padding: .3em 1em .2em;
    position: absolute;
    top: 0;
    transition: .25s all ease;
    width: 100%;
}

.#{$inuit-namespace}form__field,
%#{$inuit-namespace}form__field {
    background: $drk-color-white;
    border: 0;
    border-bottom: 1px solid $drk-color-blue;
    box-shadow: none;
    height: auto;
    line-height: 100%;
    margin: 0;
    min-height: 2.25rem;
    outline: none;
    padding: 0 1em;
    position: relative;
    width: 100%;

    @include drk-hover {
        font-size: $drk-base-font-size;
    }

    &:focus {
        border-bottom-color: $drk-color-grey;

        + .parsley-errors-list {
            visibility: hidden;
        }
    }

    &.parsley-error,
    .has-error & {
        border-bottom-color: $drk-color-red;
    }

    &:focus ~ .#{$inuit-namespace}form__label,
    &:focus ~ %#{$inuit-namespace}form__label,
    &.has-value ~ .#{$inuit-namespace}form__label,
    &.has-value ~ %#{$inuit-namespace}form__label {
        font-size: $h6-font-size;
        transform: translate3d(-1em, 2.25rem, 0);

        .no-csstransforms3d & {
            transform: translate(-1em, 2.25rem);
        }
    }

    &--select {
        @include form-select;
        background-color: $drk-color-white;
        border-bottom-color: $drk-color-blue;
        border-width: 0 0 1px;
        font-size: $drk-base-font-size;
        padding: .4em 1em;
        vertical-align: top;

        @include drk-hover {
            background-color: $drk-color-white;
            border-bottom-color: $drk-color-blue;
            cursor: pointer;
        }

        &:not(.has-value) {
            + .#{$inuit-namespace}form__label,
            + %#{$inuit-namespace}form__label {
                cursor: default;
                opacity: 0;
                z-index: -1;
            }
        }
    }

    &--textarea {
        padding-top: rem-calc($drk-base-font-size / 2);
    }


    &--date {
        + label {
            position:static;
        }

        &:focus ~ .#{$inuit-namespace}form__label,
        &:focus ~ %#{$inuit-namespace}form__label,
        &.has-value ~ .#{$inuit-namespace}form__label,
        &.has-value ~ %#{$inuit-namespace}form__label
        {
            font-size: 1rem;
            transform: none;

            .no-csstransforms3d & {
                transform: none;
            }
        }

    }
}
